import 'package:analyzer/dart/element/element.dart';
import 'package:analyzer/dart/element/visitor.dart';
import 'package:source_gen/source_gen.dart';

mixin InternalGeneratorMixin {

  List<FieldElement> fieldElementsOf(Element element) {
    final fieldElements = <FieldElement>[];
    element.visitChildren(_InternalElementVisitor(fieldElements));
    return fieldElements;
  }

  String extensionClassName(Element element, ConstantReader annotation) {
    final annotationName = annotation.objectValue.type.name;
    final className = element.name;
    return '\$$annotationName${className}Extension';
  }
}

class _InternalElementVisitor extends SimpleElementVisitor {
  final List<FieldElement> fieldElements;

  _InternalElementVisitor(this.fieldElements) : assert(fieldElements != null);

  @override
  Object visitFieldElement(FieldElement element) {
    fieldElements.add(element);
    return super.visitFieldElement(element);
  }
}
