import 'package:analyzer/dart/element/element.dart';
import 'package:auto_model/src/annotations.dart';
import 'package:build/build.dart';
import 'package:source_gen/source_gen.dart';

import 'internal_generator_mixin.dart';

class JsonGenerator extends GeneratorForAnnotation<Json>
    with InternalGeneratorMixin {
  @override
  String generateForAnnotatedElement(
      Element element, ConstantReader annotation, BuildStep buildStep) {
    final fieldElements = fieldElementsOf(element);
    if (fieldElements.isNotEmpty) {
      return '''
    extension ${extensionClassName(element, annotation)} on ${element.name} {
      /// import 'package:auto_model/auto_model.dart';
      String get json => toJson(this);  
    }
    ''';
    } else {
      throw Exception('');
    }
  }
}
